Index: /BAORadio/libindi/libindi/libs/indibase/inditelescope.cpp
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/inditelescope.cpp	(revision 641)
+++ /BAORadio/libindi/libindi/libs/indibase/inditelescope.cpp	(revision 642)
@@ -1,22 +1,20 @@
 /*******************************************************************************
-  Copyright(c) 2010 Gerry Rozema. All rights reserved.
-
-  This program is free software; you can redistribute it and/or modify it
-  under the terms of the GNU General Public License as published by the Free
-  Software Foundation; either version 2 of the License, or (at your option)
-  any later version.
-
-  This program is distributed in the hope that it will be useful, but WITHOUT
-  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
-  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
-  more details.
-
-  You should have received a copy of the GNU General Public License along with
-  this program; if not, write to the Free Software Foundation, Inc., 59
-  Temple Place - Suite 330, Boston, MA  02111-1307, USA.
-
-  The full GNU General Public License is included in this distribution in the
-  file called LICENSE.
+  Copyright(c) 2011 Gerry Rozema, Jasem Mutlaq. All rights reserved.
+
+ This library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public
+ License version 2 as published by the Free Software Foundation.
+
+ This library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Library General Public License for more details.
+
+ You should have received a copy of the GNU Library General Public License
+ along with this library; see the file COPYING.LIB.  If not, write to
+ the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ Boston, MA 02110-1301, USA.
 *******************************************************************************/
+
 
 #include "inditelescope.h"
@@ -39,9 +37,27 @@
 {
     //ctor
+    EqNV = new INumberVectorProperty;
+    EqReqNV = new INumberVectorProperty;
+    LocationNV = new INumberVectorProperty;
+    CoordSV = new ISwitchVectorProperty;
+    ParkSV = new ISwitchVectorProperty;
+    PortTV = new ITextVectorProperty;
+    MovementNSSP = new ISwitchVectorProperty;
+    MovementWESP = new ISwitchVectorProperty;
+    ConfigSV = new ISwitchVectorProperty;
+
 }
 
 INDI::Telescope::~Telescope()
 {
-    //dtor
+    delete EqNV;
+    delete EqReqNV;
+    delete LocationNV;
+    delete CoordSV;
+    delete ParkSV;
+    delete PortTV;
+    delete MovementNSSP;
+    delete MovementWESP;
+    delete ConfigSV;
 }
 
@@ -49,39 +65,41 @@
 {
     DefaultDriver::initProperties();
-
-    EqNV = new INumberVectorProperty;
 
     IUFillNumber(&EqN[0],"RA","RA (hh:mm:ss)","%010.6m",0,24,0,0);
     IUFillNumber(&EqN[1],"DEC","DEC (dd:mm:ss)","%010.6m",-90,90,0,0);
-    IUFillNumberVector(EqNV,EqN,2,deviceName(),"EQUATORIAL_EOD_COORD","Eq. Coordinates","Main Control",IP_RO,60,IPS_IDLE);
-
-    EqReqNV = new INumberVectorProperty;
+    IUFillNumberVector(EqNV,EqN,2,deviceName(),"EQUATORIAL_EOD_COORD","Eq. Coordinates",MAIN_CONTROL_TAB,IP_RO,60,IPS_IDLE);
 
     IUFillNumber(&EqReqN[0],"RA","RA (hh:mm:ss)","%010.6m",0,24,0,0);
     IUFillNumber(&EqReqN[1],"DEC","DEC (dd:mm:ss)","%010.6m",-90,90,0,0);
-    IUFillNumberVector(EqReqNV,EqReqN,2,deviceName(),"EQUATORIAL_EOD_COORD_REQUEST","GOTO","Controls",IP_WO,60,IPS_IDLE);
-
-    LocationNV = new INumberVectorProperty;
+    IUFillNumberVector(EqReqNV,EqReqN,2,deviceName(),"EQUATORIAL_EOD_COORD_REQUEST","GOTO",MAIN_CONTROL_TAB,IP_WO,60,IPS_IDLE);
 
     IUFillNumber(&LocationN[0],"LAT","Lat (dd:mm:ss)","%010.6m",-90,90,0,0.0);
-    IUFillNumber(&LocationN[1],"LONG","Lon (dd:mm:ss)","%010.6m",0,360,0,0.0 );
-    IUFillNumberVector(LocationNV,LocationN,2,deviceName(),"GEOGRAPHIC_COORD","Scope Location","Location",IP_RW,60,IPS_OK);
-
-    CoordSV = new ISwitchVectorProperty;
+    IUFillNumber(&LocationN[1],"LONG","Lon (dd:mm:ss)","%010.6m",-180,180,0,0.0 );
+    IUFillNumberVector(LocationNV,LocationN,2,deviceName(),"GEOGRAPHIC_COORD","Scope Location",SITE_TAB,IP_RW,60,IPS_OK);
 
     IUFillSwitch(&CoordS[0],"TRACK","Track",ISS_OFF);
     IUFillSwitch(&CoordS[1],"SLEW","Slew",ISS_OFF);
     IUFillSwitch(&CoordS[2],"SYNC","Sync",ISS_OFF);
-    IUFillSwitchVector(CoordSV,CoordS,3,deviceName(),"ON_COORD_SET","On Set","Controls",IP_RW,ISR_1OFMANY,60,IPS_IDLE);
-
-    ParkSV = new ISwitchVectorProperty;
+    IUFillSwitchVector(CoordSV,CoordS,3,deviceName(),"ON_COORD_SET","On Set",MAIN_CONTROL_TAB,IP_RW,ISR_1OFMANY,60,IPS_IDLE);
+
+    IUFillSwitch(&ConfigS[0], "CONFIG_LOAD", "Load", ISS_OFF);
+    IUFillSwitch(&ConfigS[1], "CONFIG_SAVE", "Save", ISS_OFF);
+    IUFillSwitch(&ConfigS[2], "CONFIG_DEFAULT", "Default", ISS_OFF);
+    IUFillSwitchVector(ConfigSV, ConfigS, 3, deviceName(), "CONFIG_PROCESS", "Configuration", "Options", IP_RW, ISR_1OFMANY, 60, IPS_IDLE);
+
 
     IUFillSwitch(&ParkS[0],"PARK","Park",ISS_OFF);
-    IUFillSwitchVector(ParkSV,ParkS,1,deviceName(),"TELESCOPE_PARK","Park","Controls",IP_RW,ISR_1OFMANY,60,IPS_IDLE);
-
-    PortTV = new ITextVectorProperty;
+    IUFillSwitchVector(ParkSV,ParkS,1,deviceName(),"TELESCOPE_PARK","Park",MAIN_CONTROL_TAB,IP_RW,ISR_1OFMANY,60,IPS_IDLE);
 
     IUFillText(&PortT[0],"PORT","Port","/dev/ttyUSB0");
-    IUFillTextVector(PortTV,PortT,1,deviceName(),"DEVICE_PORT","Ports","Options",IP_RW,60,IPS_IDLE);
+    IUFillTextVector(PortTV,PortT,1,deviceName(),"DEVICE_PORT","Ports",OPTIONS_TAB,IP_RW,60,IPS_IDLE);
+
+    IUFillSwitch(&MovementNSS[MOTION_NORTH], "MOTION_NORTH", "North", ISS_OFF);
+    IUFillSwitch(&MovementNSS[MOTION_SOUTH], "MOTION_SOUTH", "South", ISS_OFF);
+    IUFillSwitchVector(MovementNSSP, MovementNSS, 2, deviceName(),"TELESCOPE_MOTION_NS", "North/South", MOTION_TAB, IP_RW, ISR_1OFMANY, 60, IPS_IDLE);
+
+    IUFillSwitch(&MovementWES[MOTION_WEST], "MOTION_WEST", "West", ISS_OFF);
+    IUFillSwitch(&MovementWES[MOTION_EAST], "MOTION_EAST", "East", ISS_OFF);
+    IUFillSwitchVector(MovementWESP, MovementWES, 2, deviceName(),"TELESCOPE_MOTION_WE", "West/East", MOTION_TAB, IP_RW, ISR_1OFMANY, 60, IPS_IDLE);
 
     TrackState=SCOPE_PARKED;
@@ -96,5 +114,5 @@
 
     //  We may need the port set before we can connect
-    //IDDefText(&PortTV,NULL);
+    IDDefText(PortTV,NULL);
     //LoadConfig();
 
@@ -107,4 +125,8 @@
         defineNumber(LocationNV);
         defineSwitch(ParkSV);
+        defineSwitch(MovementNSSP);
+        defineSwitch(MovementWESP);
+		defineSwitch(ConfigSV);
+
     }
     return;
@@ -113,14 +135,16 @@
 bool INDI::Telescope::updateProperties()
 {
+    defineText(PortTV);
     if(isConnected())
     {
         //  Now we add our telescope specific stuff
-        //IDLog("INDI::Telescope adding properties\n");
         defineSwitch(CoordSV);
         defineNumber(EqNV);
         defineNumber(EqReqNV);
-        //IDDefText(&PortTV,NULL);
+        defineSwitch(MovementNSSP);
+        defineSwitch(MovementWESP);
         defineNumber(LocationNV);
         defineSwitch(ParkSV);
+
     } else
     {
@@ -129,19 +153,28 @@
         deleteProperty(EqNV->name);
         deleteProperty(EqReqNV->name);
-        //DeleteProperty(PortTV.name);
+        deleteProperty(MovementNSSP->name);
+        deleteProperty(MovementWESP->name);
         deleteProperty(LocationNV->name);
         deleteProperty(ParkSV->name);
 
-        initProperties();
-    }
+        //initProperties();
+    }
+	defineSwitch(ConfigSV);
+
     return true;
 }
 
-int INDI::Telescope::NewRaDec(double ra,double dec)
+bool INDI::Telescope::saveConfigItems(FILE *fp)
+{
+
+	IUSaveConfigNumber(fp,LocationNV);
+    return true;
+}
+
+void INDI::Telescope::NewRaDec(double ra,double dec)
 {
     //  Lets set our eq values to these numbers
     //  which came from the hardware
-    EqN[0].value=ra;
-    EqN[1].value=dec;
+    static int last_state=-1;
 
     if (TrackState == SCOPE_TRACKING && EqReqNV->s != IPS_OK)
@@ -150,5 +183,5 @@
         IDSetNumber(EqReqNV, NULL);
     }
-    if ( (TrackState == SCOPE_PARKED || TrackState == SCOPE_IDLE) && EqReqNV->s != IPS_IDLE)
+    else if ( (TrackState == SCOPE_PARKED || TrackState == SCOPE_IDLE) && EqReqNV->s != IPS_IDLE)
     {
         EqReqNV->s = IPS_IDLE;
@@ -156,5 +189,14 @@
     }
 
-    return 0;
+    //IDLog("newRA DEC RA %g - DEC %g --- EqN[0] %g --- EqN[1] %g --- EqN.state %d\n", ra, dec, EqN[0].value, EqN[1].value, EqNV->s);
+    if (EqN[0].value != ra || EqN[1].value != dec || EqNV->s != last_state)
+    {
+      //  IDLog("Not equal , send update to client...\n");
+        EqN[0].value=ra;
+        EqN[1].value=dec;
+        last_state = EqNV->s;
+        IDSetNumber(EqNV, NULL);
+    }
+
 }
 
@@ -176,4 +218,22 @@
     //  if we get here, our mount doesn't support sync
     IDMessage(deviceName(),"Mount does not support Sync");
+    return false;
+}
+
+bool INDI::Telescope::MoveNS(TelescopeMotionNS dir)
+{
+    IDMessage(deviceName(),"Mount does not support North/South motion");
+    IUResetSwitch(MovementNSSP);
+    MovementNSSP->s = IPS_IDLE;
+    IDSetSwitch(MovementNSSP, NULL);
+    return false;
+}
+
+bool INDI::Telescope::MoveWE(TelescopeMotionWE dir)
+{
+    IDMessage(deviceName(),"Mount does not support West/East motion");
+    IUResetSwitch(MovementWESP);
+    MovementWESP->s = IPS_IDLE;
+    IDSetSwitch(MovementWESP, NULL);
     return false;
 }
@@ -328,4 +388,33 @@
             Park();
         }
+
+        if(strcmp(name,"TELESCOPE_MOTION_NS")==0)
+        {
+            IUUpdateSwitch(MovementNSSP,states,names,n);
+
+            MovementNSSP->s = IPS_BUSY;
+
+            if (MovementNSS[MOTION_NORTH].s == ISS_ON)
+                MoveNS(MOTION_NORTH);
+            else
+                MoveNS(MOTION_SOUTH);
+
+            return true;
+        }
+
+        if(strcmp(name,"TELESCOPE_MOTION_WE")==0)
+        {
+            IUUpdateSwitch(MovementWESP,states,names,n);
+
+            MovementWESP->s = IPS_BUSY;
+
+            if (MovementWES[MOTION_WEST].s == ISS_ON)
+                MoveWE(MOTION_WEST);
+            else
+                MoveWE(MOTION_EAST);
+
+            return true;
+        }
+
     }
 
@@ -334,15 +423,22 @@
 }
 
+
 bool INDI::Telescope::Connect()
 {
     //  Parent class is wanting a connection
-    //IDLog("INDI::Telescope calling connect with %s\n",PortT[0].text);
+    if (isDebug())
+        IDLog("INDI::Telescope arrived in connect with %s\n",PortT[0].text);
     bool rc=false;
 
     if(isConnected()) return true;
 
-    //IDLog("Calling Connect\n");
+
+    if (isDebug())
+        IDLog("Telescope Calling Connect\n");
 
     rc=Connect(PortT[0].text);
+
+    if (isDebug())
+        IDLog("Telescope Connect returns %d\n",rc);
 
     if(rc)
@@ -351,4 +447,5 @@
 }
 
+
 bool INDI::Telescope::Connect(const char *port)
 {
@@ -361,10 +458,11 @@
     bool rc;
 
-
-    if ( (connectrc = tty_connect(port, B9600, 8, 0, 1, &PortFD)) != TTY_OK)
+	IDLog("Indi Telescope connecting to %s\n",port);
+
+    if ( (connectrc = tty_connect(port, 9600, 8, 0, 1, &PortFD)) != TTY_OK)
     {
         tty_error_msg(connectrc, errorMsg, MAXRBUF);
 
-        if (isDebug())
+        //if (isDebug())
             IDLog("Failed to connect o port %s. Error: %s", port, errorMsg);
         IDMessage(deviceName(), "Failed to connect to port %s. Error: %s", port, errorMsg);
@@ -373,8 +471,8 @@
 
     }
-
+	IDLog("Port Fd %d\n",PortFD);
     /* Flush the input (read) buffer */
 
-    tcflush(PortFD,TCIOFLUSH);
+    //tcflush(PortFD,TCIOFLUSH);
 
     /* Test connection */
@@ -401,4 +499,6 @@
     //Connected=false;
 
+	IDLog("IndiTelescope Disconnect\n");
+
     close(PortFD);
     IDMessage(deviceName(),"Telescope is offline.");
@@ -410,5 +510,5 @@
 void INDI::Telescope::TimerHit()
 {
-    //IDLog("Timer Hit\n");
+    //IDLog("Telescope Timer Hit\n");
     if(isConnected())
     {
@@ -417,31 +517,11 @@
         rc=ReadScopeStatus();
         //IDLog("TrackState after read is %d\n",TrackState);
-        if(rc)
-        {
-            //  read was good
-            switch(TrackState)
-            {
-              case SCOPE_IDLE:
-              case SCOPE_PARKED:
-                EqNV->s=IPS_IDLE;
-                break;
-
-             case SCOPE_SLEWING:
-             case SCOPE_PARKING:
-                EqNV->s=IPS_BUSY;
-                break;
-
-            case SCOPE_TRACKING:
-                EqNV->s=IPS_OK;
-                break;
-            }
-        } else
+        if(rc == false)
         {
             //  read was not good
             EqNV->s=IPS_ALERT;
-        }
-        //IDLog("IsConnected, re-arm timer\n");
-        //  Now update the Client data
-        IDSetNumber(EqNV,NULL);
+            IDSetNumber(EqNV, NULL);
+        }      
+
         SetTimer(POLLMS);
     }
Index: /BAORadio/libindi/libindi/libs/indibase/inditelescope.h
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/inditelescope.h	(revision 641)
+++ /BAORadio/libindi/libindi/libs/indibase/inditelescope.h	(revision 642)
@@ -1,21 +1,18 @@
 /*******************************************************************************
-  Copyright(c) 2010 Gerry Rozema. All rights reserved.
+  Copyright(c) 2011 Gerry Rozema, Jasem Mutlaq. All rights reserved.
 
-  This program is free software; you can redistribute it and/or modify it
-  under the terms of the GNU General Public License as published by the Free
-  Software Foundation; either version 2 of the License, or (at your option)
-  any later version.
+ This library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public
+ License version 2 as published by the Free Software Foundation.
 
-  This program is distributed in the hope that it will be useful, but WITHOUT
-  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
-  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
-  more details.
+ This library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Library General Public License for more details.
 
-  You should have received a copy of the GNU General Public License along with
-  this program; if not, write to the Free Software Foundation, Inc., 59
-  Temple Place - Suite 330, Boston, MA  02111-1307, USA.
-
-  The full GNU General Public License is included in this distribution in the
-  file called LICENSE.
+ You should have received a copy of the GNU Library General Public License
+ along with this library; see the file COPYING.LIB.  If not, write to
+ the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ Boston, MA 02110-1301, USA.
 *******************************************************************************/
 
@@ -25,9 +22,26 @@
 #include "defaultdriver.h"
 
+/**
+ * \class INDI::Telescope
+   \brief Class to provide general functionality of a telescope device.
+
+   Developers need to subclass INDI::Telescope to implement any driver for telescopes within INDI.
+
+   Implementing a basic telescope driver involves the child class performing the following steps:
+   <ul>
+   <li>If the telescope has additional properties, the child class should override initProperties and initilize the respective additional properties.</li>
+   <li>Once the parent class calls Connect(), the child class attempts to connect to the telescope and return either success of failure</li>
+   <li>INDI::Telescope calls updateProperties() to enable the child class to define which properties to send to the client upon connection</li>
+   <li>INDI::Telescope calls ReadScopeStatus() to check the link to the telescope and update its state and position. The child class should call newRaDec() whenever
+   a new value is read from the telescope.</li>
+   <li>The child class should implmenet Goto() and Sync(), and Park() if applicable.</li>
+   <li>INDI::Telescope calls disconnect() when the client request a disconnection. The child class should remove any additional properties it defined in updateProperties() if applicable</li>
+   </ul>
+
+\author Gerry Rozema, Jasem Mutlaq
+\see TelescopeSimulator and SynScan drivers for examples of implementations of INDI::Telescope.
+*/
 class INDI::Telescope : public INDI::DefaultDriver
 {
-    protected:
-        //bool Connected;
-
     private:
 
@@ -37,4 +51,96 @@
 
         enum TelescopeStatus { SCOPE_IDLE, SCOPE_SLEWING, SCOPE_TRACKING, SCOPE_PARKING, SCOPE_PARKED };
+        enum TelescopeMotionNS { MOTION_NORTH, MOTION_SOUTH };
+        enum TelescopeMotionWE { MOTION_WEST, MOTION_EAST };
+
+        virtual bool ISNewNumber (const char *dev, const char *name, double values[], char *names[], int n);
+        virtual bool ISNewText (const char *dev, const char *name, char *texts[], char *names[], int n);
+        virtual bool ISNewSwitch (const char *dev, const char *name, ISState *states, char *names[], int n);
+        virtual void ISGetProperties (const char *dev);
+
+        /** \brief Called to initialize basic properties required all the time */
+        virtual bool initProperties();
+        /** \brief Called when connected state changes, to add/remove properties */
+        virtual bool updateProperties();
+
+        /** \brief Called when setTimer() time is up */
+        virtual void TimerHit();
+
+        /** \brief Connect to the telescope.
+          \return True if connection is successful, false otherwise
+        */
+        virtual bool Connect();
+
+        /** \brief Disconnect from telescope
+            \return True if successful, false otherwise */
+        virtual bool Disconnect();
+
+        /** \brief INDI::Telescope implementation of Connect() assumes 9600 baud, 8 bit word, even parity, and no stop bit. Override function if communication paramaters
+          are different
+          \param port Port to connect to
+          \return True if connection is successful, false otherwise
+          \warning Do not call this function directly, it is called by INDI::Telescope Connect() function.
+        */
+        virtual bool Connect(const char *port);
+
+        protected:
+
+        virtual bool saveConfigItems(FILE *fp);
+
+        /** \brief The child class calls this function when it has updates */
+        void NewRaDec(double ra,double dec);
+
+        /** \brief Read telescope status.
+         This function checks the following:
+         <ol>
+           <li>Check if the link to the telescope is alive.</li>
+           <li>Update telescope status: Idle, Slewing, Parking..etc.</li>
+           <li>Read coordinates</li>
+         </ol>
+          \return True if reading scope status is OK, false if an error is encounterd.
+          \note This function is not implemented in INDI::Telescope, it must be implemented in the child class */
+        virtual bool ReadScopeStatus();
+
+        /** \brief Move the scope to the supplied RA and DEC coordinates
+            \return True if successful, false otherewise
+            \note This function is not implemented in INDI::Telescope, it must be implemented in the child class
+        */
+        virtual bool Goto(double ra,double dec);
+
+        /** \brief Set the telescope current RA and DEC coordinates to the supplied RA and DEC coordinates
+            \return True if successful, false otherewise
+            \note This function is not implemented in INDI::Telescope, it must be implemented in the child class
+        */
+        virtual bool Sync(double ra,double dec);
+
+        /** \brief Move the telescope in the direction dir.
+            \return True if successful, false otherewise
+            \note This function is not implemented in INDI::Telescope, it must be implemented in the child class
+        */
+        virtual bool MoveNS(TelescopeMotionNS dir);
+
+        /** \brief Move the telescope in the direction dir.
+            \return True if successful, false otherewise
+            \note This function is not implemented in INDI::Telescope, it must be implemented in the child class
+        */
+        virtual bool MoveWE(TelescopeMotionWE dir);
+
+        /** \brief Part the telescope to its home position.
+            \return True if successful, false otherewise
+            \note This function is not implemented in INDI::Telescope, it must be implemented in the child class
+        */
+        virtual bool Park();
+
+
+        //  Since every mount I know of actually uses a serial port for control
+        //  We put the serial helper into the base telescope class
+        //  One less piece to worry about in the hardware specific
+        //  low level stuff
+        int PortFD;
+
+        //  This is a variable filled in by the ReadStatus telescope
+        //  low level code, used to report current state
+        //  are we slewing, tracking, or parked.
+        TelescopeStatus TrackState;
 
         //  All telescopes should produce equatorial co-ordinates
@@ -49,4 +155,7 @@
         ISwitch CoordS[3];              //  On a coord_set message, sync, or slew
 
+        ISwitchVectorProperty *ConfigSV; //  A switch vector that stores how we should readct
+        ISwitch ConfigS[3];              //  On a coord_set message, sync, or slew
+
         INumberVectorProperty *LocationNV;   //  A number vector that stores lattitude and longitude
         INumber LocationN[2];
@@ -55,69 +164,13 @@
         ISwitch ParkS[1];
 
-        //  I dont know of any telescopes that dont
-        //  need a port for connection
-        //  So lets put all the port connect framework
-        //  into our generic telescope super class
         ITextVectorProperty *PortTV; //  A text vector that stores out physical port name
         IText PortT[1];
 
+        ISwitch MovementNSS[2];     // A switch for North/South motion
+        ISwitchVectorProperty *MovementNSSP;
 
-        //  Ok, we do need our virtual functions from the base class for processing
-        //  client requests
-        //  We process numbers,switches and text in the telescope
-        //  These are the base IndiDevice overrides we process
-        virtual bool ISNewNumber (const char *dev, const char *name, double values[], char *names[], int n);
-        virtual bool ISNewText (const char *dev, const char *name, char *texts[], char *names[], int n);
-        virtual bool ISNewSwitch (const char *dev, const char *name, ISState *states, char *names[], int n);
-        virtual void ISGetProperties (const char *dev);
+        ISwitch MovementWES[2];     // A switch for West/East motion
+        ISwitchVectorProperty *MovementWESP;
 
-        //  overrides of base class virtual functions
-        //  that are specific to our way of implementing Indi
-        virtual bool initProperties();      //  Called to initialize basic properties required all the time
-        virtual bool updateProperties();    //  Called when connected state changes, to add/remove properties
-
-        virtual void TimerHit();
-        virtual bool Connect();
-        virtual bool Disconnect();
-
-        virtual bool Connect(const char *);
-
-
-        //  Since every mount I know of actually uses a serial port for control
-        //  We put the serial helper into the base telescope class
-        //  One less piece to worry about in the hardware specific
-        //  low level stuff
-        int PortFD;
-
-
-        //  This is a variable filled in by the ReadStatus telescope
-        //  low level code, used to report current state
-        //  are we slewing, tracking, or parked.
-        int TrackState;
-
-
-        //  These functions are telescope specific
-        //  and meant to make life really easy for deriving
-        //  hardware specific telescope classes
-        int NewRaDec(double,double);    //  The child class will call this when it has updates
-
-
-        //  And these are the hardware specific functions our children need to override
-        //  They are not pure virtual, because, not all functions are relavent for all types
-        //  of mount, ie, a Goto is not relavent for a Push-to mount
-
-        /** \brief Read telescope status.
-         This function checks the following:
-         <ol>
-           <li>Check if the link to the telescope is alive.</li>
-           <li>Update telescope status: Idle, Slewing, Parking..etc.</li>
-           <li>Read coordinates</li>
-         </ol>
-          \return True if reading scope status is OK, false if an error is encounterd. */
-        virtual bool ReadScopeStatus();
-
-        virtual bool Goto(double ra,double dec);
-        virtual bool Sync(double ra,double dec);
-        virtual bool Park();
 
 };
Index: /BAORadio/libindi/libindi/libs/indibase/indiusbdevice.cpp
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/indiusbdevice.cpp	(revision 641)
+++ /BAORadio/libindi/libindi/libs/indibase/indiusbdevice.cpp	(revision 642)
@@ -1,21 +1,18 @@
 /*******************************************************************************
-  Copyright(c) 2010 Gerry Rozema. All rights reserved.
+  Copyright(c) 2011 Gerry Rozema. All rights reserved.
 
-  This program is free software; you can redistribute it and/or modify it
-  under the terms of the GNU General Public License as published by the Free
-  Software Foundation; either version 2 of the License, or (at your option)
-  any later version.
+ This library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public
+ License version 2 as published by the Free Software Foundation.
 
-  This program is distributed in the hope that it will be useful, but WITHOUT
-  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
-  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
-  more details.
+ This library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Library General Public License for more details.
 
-  You should have received a copy of the GNU General Public License along with
-  this program; if not, write to the Free Software Foundation, Inc., 59
-  Temple Place - Suite 330, Boston, MA  02111-1307, USA.
-
-  The full GNU General Public License is included in this distribution in the
-  file called LICENSE.
+ You should have received a copy of the GNU Library General Public License
+ along with this library; see the file COPYING.LIB.  If not, write to
+ the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ Boston, MA 02110-1301, USA.
 *******************************************************************************/
 #include "indiusbdevice.h"
@@ -149,15 +146,15 @@
 }
 
-int INDI::USBDevice::ReadBulk(char *buf,int c,int timeout)
+int INDI::USBDevice::ReadBulk(char *buf,int nbytes,int timeout)
 {
 	int rc;
 
 	//rc=usb_interrupt_read(usb_handle,InputEndpoint,buf,c,timeout);
-	rc=usb_bulk_read(usb_handle,InputEndpoint,buf,c,timeout);
+        rc=usb_bulk_read(usb_handle,InputEndpoint,buf,nbytes,timeout);
 	return rc;
 
 }
 
-int INDI::USBDevice::WriteBulk(char *buf,int c,int timeout)
+int INDI::USBDevice::WriteBulk(char *buf,int nbytes,int timeout)
 {
 	int rc;
@@ -165,5 +162,5 @@
 	//printf("Writing %02x to endpoint %d\n",buf[0],OutputEndpoint);
 	//rc=usb_interrupt_write(usb_handle,OutputEndpoint,buf,c,timeout);
-	rc=usb_bulk_write(usb_handle,OutputEndpoint,buf,c,timeout);
+        rc=usb_bulk_write(usb_handle,OutputEndpoint,buf,nbytes,timeout);
 	return rc;
 
Index: /BAORadio/libindi/libindi/libs/indibase/indiusbdevice.h
===================================================================
--- /BAORadio/libindi/libindi/libs/indibase/indiusbdevice.h	(revision 641)
+++ /BAORadio/libindi/libindi/libs/indibase/indiusbdevice.h	(revision 642)
@@ -1,21 +1,18 @@
 /*******************************************************************************
-  Copyright(c) 2010 Gerry Rozema. All rights reserved.
+  Copyright(c) 2011 Gerry Rozema. All rights reserved.
 
-  This program is free software; you can redistribute it and/or modify it
-  under the terms of the GNU General Public License as published by the Free
-  Software Foundation; either version 2 of the License, or (at your option)
-  any later version.
+ This library is free software; you can redistribute it and/or
+ modify it under the terms of the GNU Library General Public
+ License version 2 as published by the Free Software Foundation.
 
-  This program is distributed in the hope that it will be useful, but WITHOUT
-  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
-  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
-  more details.
+ This library is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ Library General Public License for more details.
 
-  You should have received a copy of the GNU General Public License along with
-  this program; if not, write to the Free Software Foundation, Inc., 59
-  Temple Place - Suite 330, Boston, MA  02111-1307, USA.
-
-  The full GNU General Public License is included in this distribution in the
-  file called LICENSE.
+ You should have received a copy of the GNU Library General Public License
+ along with this library; see the file COPYING.LIB.  If not, write to
+ the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ Boston, MA 02110-1301, USA.
 *******************************************************************************/
 
@@ -34,4 +31,13 @@
 #include "indibase.h"
 
+/**
+ * \class INDI::USBDevice
+   \brief Class to provide general functionality of a generic USB device.
+
+   Developers need to subclass INDI::USBDevice to implement any driver within INDI that requires direct read/write/control over USB.
+
+\author Gerry Rozema
+\see Starlight Xpress INDI CCD driver for an example implementation of INDI::USBDevice
+*/
 class INDI::USBDevice
 {
@@ -56,6 +62,6 @@
 	int ControlMessage();
 
-	int WriteBulk(char *,int,int);
-	int ReadBulk(char *,int,int);
+        int WriteBulk(char *buf,int nbytes,int timeout);
+        int ReadBulk(char *buf,int nbytes,int timeout);
 	int FindEndpoints();
 	int Open();
Index: /BAORadio/libindi/libindi/libs/indicom.c
===================================================================
--- /BAORadio/libindi/libindi/libs/indicom.c	(revision 641)
+++ /BAORadio/libindi/libindi/libs/indicom.c	(revision 642)
@@ -147,5 +147,5 @@
 	default:
 	    printf ("fs_sexa: unknown fracbase: %d\n", fracbase);
-	    exit(1);
+            return -1;
 	}
 
@@ -389,5 +389,5 @@
 }
 
-#ifdef BSD
+#if defined(BSD) && !defined(__GNU__)
 // BSD - OSX version
 int tty_connect(const char *device, int bit_rate, int word_size, int parity, int stop_bits, int *fd)
@@ -949,5 +949,5 @@
         default:
             fprintf (stderr, "Impossible IPState %d\n", s);
-            exit(1);
+            return NULL;
         }
 }
@@ -1007,4 +1007,5 @@
         default:
             fprintf (stderr, "Impossible ISState %d\n", s);
+            return NULL;
         }
 }
@@ -1020,4 +1021,5 @@
         default:
             fprintf (stderr, "Impossible ISRule %d\n", r);
+            return NULL;
         }
 }
@@ -1033,4 +1035,5 @@
         default:
             fprintf (stderr, "Impossible IPerm %d\n", p);
+            return NULL;
         }
 }
